// Bacasable3.pde
// Gerard Paresys
// 21 10 2015
//
// OK  Processing 2.0.3  2.2.1  MacOSX
// NON Processing 3
// OK Kinect 1414 (original kinect)
//
// Utilise la "contributed library" SimpleOpenNI Version 1.96 by Max Rheiner
// "Processing Wrapper for the OpenNI/Kinect library"
// http://code.google.com/p/simple-openni
// http://iad.zhdk.ch/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// cf Processing/libraries/SimpleOpenNI/examples/OpenNI/DepthImage/DepthImage.pde
//
// Touche Clavier:
//   D Image Depth
//   I Image InfraRed
//   U Image User
//   H Image HeightMap
//   M Mesure 12 zones
//   V Viseur
//   Z Zoom
//   C Couleur
//   B Blur
//   Fleche Up   Lumiere +
//   Fleche Down Lumiere -
//   S Sauve l'ecran (format png) dans le dossier du sketch (nombre = Numero frame)
//   M miroir (ne fonctionne qu'en InfaRed)

import SimpleOpenNI.*;
import peasy.*;
import ddf.minim.*;         // pour AudioPlayer


boolean FlagPeasyCam = false;
boolean PleinEcran = true;
boolean Miroir = false;
String Image = "D";
Boolean Viseur = true;
Boolean Zoom = false;
Boolean Couleur = true;
Boolean Blur = false;
Boolean Mesure = true;
boolean Verbose = true;

int x1 = 0, y1 = 0, x2 = 640, y2 = 480; 
float b;


SimpleOpenNI  Kinect;

PImage Image1;
int TailleX = 320, TailleY = 240, TailleXdemi = 160, TailleYdemi = 120;
float[][] hm  = new float[TailleX][TailleY]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[TailleX][TailleY];

PeasyCam pcam;
CameraState  pcamstate;

int[] depthMap;
int index;
float Facteur = 10;

int[] flame_palette; // flame colors

int[] Acc = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

String ExtensionFichierAudio = ".wav"; // ".wav" ".mp3"
String Content1 = "", Content2 = "", Content = "", Nom = "";
String NomFichierXML = "ESLO2_REPAS_1270.xml"; //
String[] TableNomFichier = {
  "ESLO1_ENT_010.xml", 
  "ESLO1_ENT_110.xml", 
  "ESLO1_INTPERS_423.xml", 
  "ESLO1_INTPERS_439.xml", 
  "ESLO2_CONF_1243.xml", 
  "ESLO2_DIA_1227.xml", 
  "ESLO2_ENT_1012.xml", 
  "ESLO2_ENT_1027.xml", 
  "ESLO2_ENT_1028.xml", 
  "ESLO2_ENT_1049.xml", 
  "ESLO2_ENT_1062.xml", 
  "ESLO2_ENT_1076.xml", 
  "ESLO2_REPAS_1270.xml"
}; //
XML[] XMLTranscription, XMLPhoneme, XMLMot, XMLSyllabe;
int NombreSegment;
Minim minim;
AudioPlayer player;
boolean FichierOuvert = false;
float xmin, xmax;  // Temps en seconde
int IndexXML = 0, Segment;
float Temps, TempsPause = 0, TempsDebutPause = 0;
int ZoneMaxAvant = 0, ZoneMax = 0, Max = 0;


void setup() {
  // size(640, 480, P3D);
  // size(1280, 960, P3D);
  if (PleinEcran) size(displayWidth, displayHeight, P3D);
  else size(640, 480, P3D);
  x2 = width;
  y2 = height;

  Kinect = new SimpleOpenNI(this);
  if (Kinect.isInit() == false) {
    println("Can't init SimpleOpenNI, maybe the camera is not connected!"); 
    exit();
    return;
  }
  Kinect.enableDepth();
  // Kinect.enableRGB();
  Kinect.enableIR(); // IR is only available if there is no RGBImage activated at the same time
  Kinect.enableUser();
  Kinect.setMirror(Miroir);
  Kinect.alternativeViewPointDepthToImage();
  Kinect.setDepthColorSyncEnabled(true);



  println("Kinect.depthWidth() = " + Kinect.depthWidth() + "    Kinect.depthHeight() = " + Kinect.depthHeight()); 
  if (FlagPeasyCam) {
    // pcam = new PeasyCam(this, width/2, height/2, 0, 600); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
    pcam = new PeasyCam(this, width/2, height/2, 0, 300); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
    pcam.setMinimumDistance(50);
    pcam.setMaximumDistance(1000);
    // pcam.rotateX(-PI/4);
    pcam.rotateX(-PI/8);
    pcamstate = pcam.getState();
  }
  flame_palette = new int[256];
  for (int i=0; i<64; i++) {
    //    flame_palette[i]  = color(i<<2, 0, 0, i<<3);      // Black to red
    //    flame_palette[i+64]  = color(255, i<<2, 0); // Red to yellow
    //    flame_palette[i+128]  = color(255, 255, i<<2); // Yellow to white, 
    //    flame_palette[i+192]  = color(255, 255, 255);   // White
    flame_palette[i]  = color(0, 0, i * 4);      // Black to blue
    flame_palette[i+64]  = color(i * 4, i * 4, 252); // blue to white
    flame_palette[i+128]  = color(252, 252, (64 - i) * 4); // white to Yellow, 
    // flame_palette[i+192]  = color((64 - i) * 4, (64 - i) * 4, 0);   // White
    flame_palette[i+192]  = color(252, (126 - i) * 2, 0);   // Yellow to Orange
  }

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) {
    Ouverture(NomFichierXML);
    Nom = split(Fichier.getName(), '.')[0];
  } else selectInput("select the XML File (format Praat textGrid):", "SelectionFichier");
}

void draw() {
  // background(0);  // 0 
  if (Blur) {
    fill(0, 20); // semi-transparent black
    rect(0, 0, width, height);
  } else background(0);
  Kinect.update();
  if (Image.equals("H")) {
    depthMap = Kinect.depthMap();
    Calculhm();
    pushMatrix();
    translate(width/2, height/2);
    paintLandscape();
    popMatrix();
  } else {
    if (Image.equals("D")) {
      Image1 = Kinect.depthImage();
      if (Couleur) {
        for (int i = 0; i < (Image1.width * Image1.height); i++) {
          b = brightness(Image1.pixels[i]) * Facteur / 10;
          b = max(min(b, 255), 0);
          Image1.pixels[i] = flame_palette[int(b)];
        }
      }
      // else image(Kinect.depthImage(), x1, y1, x2, y2);
      else {
        for (int i = 0; i < (Image1.width * Image1.height); i++) {
          b = brightness(Image1.pixels[i]) * Facteur / 10;
          b = max(min(b, 255), 0);
          Image1.pixels[i] = color(b);
        }
      }
    }
    // if (Image.equals("R")) image(Kinect.rgbImage(), x1, y1, x2, y2);
    if (Image.equals("I")) Image1 = Kinect.irImage();
    if (Image.equals("U")) Image1 = Kinect.userImage();
    Image1.updatePixels();
    if (Blur) tint(255, 20); // Apply transparency without changing color
    else noTint(); 
    image(Image1, x1, y1, x2, y2);
  }
  if (Mesure) { // 4 x 3 carres 160 x 160
    Image1 = Kinect.depthImage();
    Image1.loadPixels();
    fill(255, 0, 0);            // Rouge
    textAlign(CENTER, CENTER);       //RIGHT LEFT BOTTOM BASELINE TOP
    textSize(32);
    for (int x = 0; x < 4; x++) {
      for (int y = 0; y < 3; y++) {
        Acc[x + 4*y] = 0;
        int Decalage = (x * 160) + (y * 160 * 640);
        for (int u = 0; u < 160; u++) {
          for (int v = 0; v < 160; v++) {
            Acc[x + 4*y] = Acc[x + 4*y] + int(brightness(Image1.pixels[u + (v * 640) + Decalage]));
          }
        }
        // text(int(Acc / 10000.0), x * 160 + 80, y * 160 + 80);
        text(int(Acc[x + 4*y] / 10000.0), x * width / 4 + width / 8, y * height / 3 + height / 6);
      }
    }
    ZoneMax = 0;
    Max = 0;
    for (int x = 0; x < Acc.length; x++) {
      if (Acc[x] > Max) {
        Max = Acc[x];
        ZoneMax = x;
      }
    }
    if (ZoneMaxAvant != ZoneMax) {
      ZoneMaxAvant = ZoneMax;
      Ouverture(TableNomFichier[ZoneMax]);
    }
  }
  if (Viseur) { // 4 x 3 = 12 carres rouges
    stroke(255, 0, 0); // Rouge
    strokeWeight(1);
    noFill();
    for (int x = 0; x < 5; x++) line(x * width / 4, 0, x * width / 4, height);
    for (int y = 0; y < 4; y++) line(0, y * height / 3, width, y * height / 3);
  }
  frame.setTitle( "kinect     " + int(10 * frameRate) / 10.0 + " fps");
}

void Calculhm1() {
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(brightness(Image1.pixels[(x * 2) + (y * 4 * TailleX)]) / 8.f, 100), 0);
  }
}

void Calculhm2() {
  // Voir: SimpleOpenNI/examples/OpenNI/AlternativeViewpoint3d/AlternativeViewpoint3d.pde
  //   et: SimpleOpenNI/examples/Extensions/IntersectionTest/IntersectionTest.pde
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) { 
      index = (x * 2) + (y * 2 * Kinect.depthWidth());
      // hm[x][y] = depthMap[index];
      // hm[x][y] = max(min(depthMap[index]/ 40.f, 100), 0);
      hm[x][y] = max(min(depthMap[index]/ Facteur, 100), 0);
    }
  }
}

void Calculhm3() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(
      ( brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]) 
        + brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)])
        + brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])
        + brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  32.0, 100.0), -3.0);
  }
}

void Calculhm() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = min(max(max(
      brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])), 
      brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  10.0, 100.0);
  }
}

void paintLandscape() {
  noStroke();
  scale(1.8);
  if (Blur) tint(255, 20); // Apply transparency without changing color
  else noTint(); 

  for ( int x = 3; x < TailleX-5; x++) {
    beginShape(QUADS);
    for ( int y = 3; y < TailleY-5; y++) {
      if (Couleur) {
        // b = hm[x][y] * 8;
        b = hm[x][y] * Facteur;
        // if ((b >= 0) & (b < 256)) fill(flame_palette[int(b)]);
        b = max(min(b, 255), 0);
        fill(flame_palette[int(b)]);
      }
      // else fill((hm[x][y] *12), (hm[x][y] * 12), (hm[x][y] * 12));
      // else fill((hm[x][y] *8), (hm[x][y] * 8), (hm[x][y] * 8));
      else fill((hm[x][y] * Facteur));
      vertex(x     - TailleXdemi, y     - TailleYdemi, hm[x]  [y]);
      vertex(x + 1 - TailleXdemi, y     - TailleYdemi, hm[x+1][y]);
      vertex(x + 1 - TailleXdemi, y + 1 - TailleYdemi, hm[x+1][y+1]);
      vertex(x     - TailleXdemi, y + 1 - TailleYdemi, hm[x]  [y+1]);
    }
    endShape();
  }
}


void keyPressed() {
  if ( key == 'd' || key == 'D' ) Image = "D";
  // else if ( key == 'r' || key == 'R' ) Image = "R";
  else if ( key == 'b' || key == 'B' ) Blur = !Blur;
  else if ( key == 'm' || key == 'M' ) Mesure = !Mesure;
  else if ( key == 'i' || key == 'I' ) Image = "I";
  else if ( key == 'u' || key == 'U' ) Image = "U";
  else if ( key == 'h' || key == 'H' ) Image = "H";
  else if ( key == 'v' || key == 'V' ) Viseur      = !Viseur;
  else if ( key == 'z' || key == 'Z' ) {
    Zoom      = !Zoom;
    if (Zoom) {
      x1 = -320;
      y1 = -240;
      x2 = 1280;
      y2 = 960;
    } else {
      x1 = 0;
      y1 = 0;
      x2 = 640;
      y2 = 480;
    }
  } else if ( key == 'c' || key == 'C' ) Couleur      = !Couleur;
  else if ( key == 's' || key == 'S' ) saveFrame("Display-" + frameCount + ".png"); // S Sauve l'ecran
  else if ( key == 'm' || key == 'M' ) {
    Miroir = !Miroir; 
    Kinect.setMirror(Miroir);
  } else if ( key == '0' ) Ouverture(TableNomFichier[0]); // 
  else if ( key == '1' ) Ouverture(TableNomFichier[1]); // 
  else if ( key == '2' ) Ouverture(TableNomFichier[2]); // 
  else if ( key == '3' ) Ouverture(TableNomFichier[3]); // 
  else if ( key == '4' ) Ouverture(TableNomFichier[4]); // 
  else if ( key == '5' ) Ouverture(TableNomFichier[5]); // 
  else if ( key == '6' ) Ouverture(TableNomFichier[6]); // 
  else if ( key == '7' ) Ouverture(TableNomFichier[7]); // 
  else if ( key == '8' ) Ouverture(TableNomFichier[8]); // 
  else if ( key == '9' ) Ouverture(TableNomFichier[9]); // 
  if (key == CODED) {
    if (keyCode == UP) {
      Facteur = Facteur * 1.2;
      println("Facteur = " + Facteur);
    } else if (keyCode == DOWN) {
      Facteur = Facteur / 1.2;
      println("Facteur = " + Facteur);
    }
  }
}

void FinOuverture() {
  minim = new Minim(this);
  player = minim.loadFile(NomFichierAudio, 1024);
  FichierOuvert = true;
  xmax = 0;
  IndexXML = -1;
  // Lissage();
  player.play();
  TempsPause = millis();
}

boolean sketchFullScreen() {
  println("PleinEcran = " + PleinEcran);
  return PleinEcran;
}

